function [mask] = blending_f(ec, x0, y0)
pix_max = 256;
mask = zeros(pix_max);

w = 14; % w is the width of the outer blending region.
% w = 0; % w is the width of the outer blending region.

if (ec == 10) % in case of the first circle - half of the blending region.
    w = round(w/2);
end

ec = ec + round(w/2);

x1 = x0- (ec+w);    if (x1<1)                  x1 = 1;               end
x2 = x0+(ec+w);    if (x2>pix_max)    x2 = pix_max; end
y1 = y0- (ec+w);    if (y1<1)                  y1 = 1;               end
y2 = y0+(ec+w);    if (y2>pix_max)    y2 = pix_max; end

for y = y1:y2
    for x = x1:x2
        if (((y - y0)^2 + (x - x0)^2 > (ec - w)^2) & ((y - y0)^2 + (x - x0)^2 <= (ec)^2))
            e = floor(sqrt((x - x0)^2 + (y - y0)^2));
            mask(x, y) = 0.5 * cos(pi/(w) * (e - ec+w)) + 0.5;
        end
        if (((y - y0)^2+(x - x0)^2 <= (ec - w)^2))
            mask(x, y)= 1;
        end
    end
end

