%functions:
%multOrient_fov_scale, multOrient_ecc_scale,  blending_f
function [img_new_bip] = dif_edge_ecc(filename, X, x0_global, y0_global, x0, y0,Xa)

%cutting the image 256x256
X = X(y0_global - 128 : y0_global + 127, x0_global - 128:x0_global + 127);

%X=Xa;
[N M]=size(X)
m1=abs(X-mean(mean(X))).^2;
vmg=mean(mean(m1));
e=13.5*randn(N,M);
e1=(abs(e-mean(mean(e)))).^2;
ve=mean(mean(e1));
SNR=10*log10(vmg/ve)       %
E=fft2(e);
G=fft2(X)+E;
X=real(ifft2(G));

%normalizing the image
X = X - min(min(X));                               % uniform values from 0 to 255
X = X / max(max(X)) * 255;                     % uniform values from 0 to 255
img = 'X';                                                  % the name of the image

img_new_bip = X;0
d_ec = 20;                               % ec = eccentricity. 30 deg  = 256 pix => 4 deg = 35 pix

ec_vec = [ round(d_ec/2) ,  (d_ec:d_ec:180) ];
d_degree = 4;                       %4 degree step

for ind = 1: length(ec_vec)                           
    ec = ec_vec(ind);           % 10   20   40   60  ...  180
    
    if (ind == 1)
        eccentricity = round(d_degree/2);       %eccentricity = 2
    else
        eccentricity = (ind - 1) * d_degree ;     %   eccentricity = 4, 8, 12, 16, 20, 24, 28  ; 4 deg step.
    end   %if

    %determining the Hcut, Lcut Parameters considering the eccentricity
    if (eccentricity == 2)
        Hcut = 1;
        Lcut = 3;
        [orig, img_new_bip, ind11, ind01] = multOrient_fov_scale(img,X);
    elseif(eccentricity == 4 )
        Hcut = 2;
        Lcut = 3;
    elseif(eccentricity == 8 )
        Hcut = 2;
        Lcut = 3;
    elseif(eccentricity == 12 )
        Hcut = 2;
        Lcut = 3;
    elseif(eccentricity == 16 )
        Hcut = 3;
        Lcut = 2;
    else
        Hcut = 3;
        Lcut = 2;
    end
    
    blend_const = blending_f(ec, y0, x0); % creating the mask and the blending function 
    
    % changing resolution to the image 'X', with respect to the eccentricity
    % and performance of the bipolar edge detection with respect to Hcut,
    % Lcut.
    [orig, imgecc_bip, ind12, ind02] = multOrient_ecc_scale(img, X, eccentricity, Hcut, Lcut);
    
    % summing the mask that have been multiplied with the image
    img_new_bip    = blend_const .* img_new_bip;
    orig_new_bip  = (1-blend_const) .* imgecc_bip;
    img_new_bip     = img_new_bip + orig_new_bip;
end


