clear all;
close all;
%clc;

% Simulation, For Registration by two cut images
filename = 'im6.jpg';

% load vessels  %256x256x32 array created by the program 'arrange'
% for N=1:1:32
%   eval(sprintf('a%d=vessels(:,:,N);' ,N));
% end
% clear vessels
% X=a4;A=X;


% %loading the original image for cutting
X_512 = imread(filename);

% % for RGB images
% Ahsv = rgb2hsv(X_512);
% lum = Ahsv(:, :, 3);                 % h-hue, s-saturation, v-value
% X_512 = lum;
% clear Ahsv lum;

%% for uint8 images(square1)
X_512=double(X_512);

figure(1);
colormap(gray);
imagesc(X_512);
title('X 512x512');
axis square;
%pause;
%%%%%%% Add noise %%%%%%%%%%%%%%%%%
% [N M]=size(X_512)
% m1=abs(X_512-mean(mean(X_512))).^2;
% vmg=mean(mean(m1));
% e=12.8*randn(N,M);
% e1=(abs(e-mean(mean(e)))).^2;
% ve=mean(mean(e1));
% SNR=10*log10(vmg/ve)       %
% E=fft2(e);
% G=fft2(X_512)+E;
% X_512=real(ifft2(G));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% random numbers between 49 to (-49) that defines 'x' or 'y'  pixels the image moved
pix_shft = 49;
%dx =  round(pix_shft*(2*rand(1)-1))
%dy =  round(pix_shft*(2*rand(1)-1)) 
dx=-15*4
dy=-50

% axis where the images will be cut
x01_global = 180;
y01_global = 180;

% axis where the  shifted images will be cut
x02_global = x01_global - dx;
y02_global = y01_global - dy;

% x02_global = 380;
% y02_global = 340;

% % Simulation, For Registration by two cut images
% the original 256x256
X = X_512(y01_global - 128 : y01_global + 127, x01_global - 128:x01_global + 127);%cutting the image 256x256

figure(2);
colormap(gray);
imagesc(X);
title('X 256x256');
axis square;
%pause;

x0=120; %x0 = 70;                     %the x axis of the fovea
y0=120; %y0 = 172;                   %the y axis of the fovea

% returns a multi-resolution image
X1 = dif_ecc2(filename, X_512, x01_global, y01_global, x0, y0);        
% returns a multi-resolution  shifted image
X2 = dif_ecc2(filename, X_512, x02_global, y02_global, x0, y0);   

figure(7);
colormap(gray);
subplot(2,3,1);
imagesc(X1); title('a');
axis square;

subplot(2,3,2); 
imagesc(X2); title('b');
axis square;
 
%%%%%%%%  return


% returns a multi-resolution bipolar image
X1_bip = dif_edge_ecc(filename, X_512, x01_global, y01_global, x0, y0);    
% returns a multi-resolution bipolar shifted image
X2_bip = dif_edge_ecc(filename, X_512, x02_global, y02_global, x0, y0);

subplot(2,3,4); 
imagesc(X1_bip); title('d');
axis square;

subplot(2,3,5);
imagesc(X2_bip); title('e');
axis square;

%%%%%% Add noise %%%%%%%%%%%%%%%%%
[N M]=size(X1);
m1=abs(X1-mean(mean(X1))).^2;
vmg=mean(mean(m1));
e=2*randn(N,M);
e1=(abs(e-mean(mean(e)))).^2;
ve=mean(mean(e1));
SNR=10*log10(vmg/ve)       %
E=fft2(e);
G=fft2(X1)+E;
X1=real(ifft2(G));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Add noise %%%%%%%%%%%%%%%%%
[N M]=size(X2);
m1=abs(X2-mean(mean(X2))).^2;
vmg=mean(mean(m1));
e=2*randn(N,M);
e1=(abs(e-mean(mean(e)))).^2;
ve=mean(mean(e1));
SNR=10*log10(vmg/ve)       %
E=fft2(e);
G=fft2(X2)+E;
X2=real(ifft2(G));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%% Add noise %%%%%%%%%%%%%%%%%
[N M]=size(X1_bip);
m1=abs(X1_bip-mean(mean(X1_bip))).^2;
vmg=mean(mean(m1));
e=2*randn(N,M);
e1=(abs(e-mean(mean(e)))).^2;
ve=mean(mean(e1));
SNR=10*log10(vmg/ve)       %
E=fft2(e);
G=fft2(X1_bip)+E;
X1_bip=real(ifft2(G));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Add noise %%%%%%%%%%%%%%%%%
[N M]=size(X2_bip);
m1=abs(X2_bip-mean(mean(X2_bip))).^2;
vmg=mean(mean(m1));
e=2*randn(N,M);
e1=(abs(e-mean(mean(e)))).^2;
ve=mean(mean(e1));
SNR=10*log10(vmg/ve)       %
E=fft2(e);
G=fft2(X2_bip)+E;
X2_bip=real(ifft2(G));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% registration process, returns indices of how much pixels have been moved
% registration of gray level multi-resolution images
SSAVD1 = reg_ecc('gray level', X1, X2);
% registration of bipolar multi-resolution images
SSAVD1_bip = reg_ecc('bipolar', X1_bip, X2_bip);

T=100;
T2 = T/2;
XX=[ -T2:1:T2 ];
YY=[ -T2:1:T2 ];

% colormap(gray);
% subplot(2,3,3); 
% imagesc(XX, YY, SSAVD1); title('c');
% axis square;
% set(gca,'xtick',[-50:25:50]);
% set(gca,'ytick',[-50:25:50]);
% 
% subplot(2,3,6); 
% imagesc(XX, YY, SSAVD1_bip); title('f');
% axis square;
% set(gca,'xtick',[-50:25:50]);
% set(gca,'ytick',[-50:25:50]);

true_dx=dx;
true_dy=dy;
true_dx
true_dy
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(4);colormap(gray);
imagesc(X1); title('a');axis off;truesize;

figure(5);colormap(gray);
imagesc(X2); title('c');axis off;truesize;

figure(6);colormap(gray);
imagesc(X1_bip); title('b');axis off;truesize;

figure(7); clf; colormap(gray);
imagesc(X2_bip); title('d');axis off;truesize;

figure(8);colormap(gray);
%imagesc(XX, YY, SSAVD1); title('e');truesize;%should be SSAVD1' for phase
XX_phase=-125:1:125;YY_phase=-125:1:125;
imagesc(XX_phase,YY_phase,fftshift(abs(SSAVD1)));title('e');
%imagesc(XX_phase,YY_phase,rot90(rot90(abs(SSAVD1))));

figure(9);colormap(gray);
%imagesc(XX, YY, SSAVD1_bip); title('f');truesize;%should be SSAVD1_bip' for phase
imagesc(XX_phase,YY_phase,fftshift(abs(SSAVD1_bip)));title('f');
%imagesc(XX_phase,YY_phase,fliplr(fliplr(abs(SSAVD1_bip))));


figure(10);colormap(gray);
filename = 'im6.jpg';
X_512 = double(imread(filename));
X = X_512(y01_global - 128 : y01_global + 127, x01_global - 128:x01_global + 127);%cutting the image 256x256
imagesc(X);truesize;
title('a');

figure(11);colormap(gray);
filename = 'im6.jpg';
X_512 = double(imread(filename));
X = X_512(y02_global - 128 : y02_global + 127, x02_global - 128:x02_global + 127);%cutting the image 256x256
imagesc(X);truesize;
title('b');

% figure(12);colormap(gray);
% filename = 'im8.jpg';
% X_512 = double(imread(filename));
% pix_shft = 49;
% dx=38;dy=-20;
% x01_global = 290;y01_global = 220;
% x02_global = x01_global - dx;
% y02_global = y01_global - dy;
% X = X_512(y01_global - 128 : y01_global + 127, x01_global - 128:x01_global + 127);%cutting the image 256x256
% imagesc(X);truesize;
% title('IMG2');


