function [orig, orig1, ind4, ind6] = multOrient2(img, X, eccentricity, Hcut, Lcut )
% Based on multOrient2 performs the visual based feature extraction 
% for different eccentricities - all eccentricities and orders
%-------------------------------------------------------------

%dir = 'd:\images\bw';  % directory with images
%load clena256
%img = 'clena256';
%load trees
%rect=[1 1 255 255]; X=imcrop(X,rect);
%img='X';
displayBands = 1;            % display: 1 = bandpass, 0 = edges
trackAngle = -1;	%0,90			  % Display which orientation?

% Hcut = 2;            % How many high-order octaves to drop
% Lcut = 2;            % How many low-order octaves to drop (Lcut-1)

num = 2;                      % how many orientations?
cscale = 0; fscale = 0;			% randomization parameters

fprintf('loading %s...\n',img);

%eval(sprintf('load %s\\%s;', dir, img));
eval(sprintf('orig =  %s;', img));

[R, C] = size(orig);
%total_pix=zeros(7,7);
%total_int=zeros(7,7);
% Calculate number of orders from size;
Lowest = Lcut; Highest = round(log2(R/2)-Hcut); %@

fprintf('calculating threshold...\n');
% The extrapolated threshold vector (for orders 3 - 8)
%CSF_fovea=[.004,.003,.004,.004,.014,.033];
thM = extrapthresh([.004,.003,.004,.004,.014,.033]);

Img = fft2(orig);   
dc = Img(1,1)/(R*C); % the (0,0) in Fourier is the average*R*C
Img = fftshift(Img); %and therefore dc is the average of the real spatial image
                     %dc is to normalize the contrast and the image
%------------------------------------------------------------
a=0.04;
deg=4;
max_lg_f=round(log2((R/2)/deg));
min_lg_f=round(log2(1/deg));
%x_vect=[1/deg:((R/2)/deg-1/deg)/(sz1-1):(R/2)/deg];
lg_cpd=[min_lg_f:1:max_lg_f];
cpd=2.^lg_cpd;
ex_fov_CSF=thM(:,1);
thrf1=find(thM(:,2)==1/deg)+1;
thrf2=find(thM(:,2)==(R/2)/deg);
thrf2=12
ex_fov_CSF=ex_fov_CSF(thrf1:thrf2);ex_fov_CSF=ex_fov_CSF';%extrapolated foveal CSF
%for eccentricity=0:5:30;
%eccentricity=20;
  ln_CSF_ecc=a*eccentricity*2.^lg_cpd+log2(ex_fov_CSF);
  CSF_ecc=2.^ln_CSF_ecc;
  %loglog(2.^lg_cpd,CSF_ecc,'ro:');hold on
%end
%axis([0.25 32 0.001 10]);

%thM = extrapthresh(CSF_ecc);

%hold off
%-----------------------------------------------------------

%tbase = 3;  %@This is based on a 4 degree image,
% where we start at 1/4 c/deg. <tbase> is the offset in the 
% extrapolated threshold vector based on image size in degrees.
%thM is the extrapolated thresh. between 2^-5 to 2^8,
%1/4 is 2^-2 so we start from (2^-5+3) = 2^-5+tbase

fprintf('calculating orders...\n');
for this_order = Lowest:Highest
   fprintf('%d ', this_order);
   eval(sprintf('bpimg%d = logcosine(Img,%d);', ...
      this_order, this_order));
   for j = 0:num-1
      this_angle = round(180/num*j) ;
      eval(sprintf('img%d_%d = real(hilbert2d(bpimg%d,%d,num));', ... 
         this_order, this_angle, this_order, this_angle));
   end
end


fprintf('\nlocating congruent values...\n');

% initialize
pos = ones(R,C); neg = ones(R,C);

for j = 0:num-1
   this_angle = round(180/num*j) ;
   eval(sprintf('pos%d = ones(R,C);', this_angle));
   eval(sprintf('neg%d = ones(R,C);', this_angle));
end	
   
ec=(eccentricity/5)+1;

for this_order = Lowest:Highest
   
   %thr = thM(this_order + tbase);% 6,7,8,9
   thr = CSF_ecc(this_order);
   fprintf('Order: %i Threshold used:%g,  \n', this_order, thr);
   
   % HIGH AND LOW: values that are true positive or
   %               negative (ie, not within threshold)
   eval(sprintf('high = (bpimg%d > thr*dc);', this_order));
   eval(sprintf('low = (bpimg%d < -thr*dc);', this_order));     
   
   %eval(sprintf('total_int(ec,this_order)=(sum(abs(bpimg%d(high)))+sum(abs(bpimg%d(low))))/(dc);',this_order,this_order));
   %total_pix(ec,this_order)=(sum(sum(abs(high)))+sum(sum(abs(low))))/(R*C);
   
   % POS AND NEG: cumulative image from ANDing orders
   
   pos = pos & high;
   neg = neg & low;
   
   % HIGH_ORDER_ANGLE AND LOW_ORDER_ANGLE: oriented orders
   % POS_ANGLE AND NEG_ANGLE: cumulative oriented
   
   for j = 0:num-1
      this_angle = round(180/num*j) ;      
      eval(sprintf('high%d_%d = (img%d_%d > thr*dc);', ...
         this_order, this_angle, this_order, this_angle));   
      eval(sprintf('pos%d = pos%d & high%d_%d;', ...
         this_angle, this_angle, this_order, this_angle));  
      
      eval(sprintf('low%d_%d = (img%d_%d < -thr*dc);', ...
         this_order, this_angle, this_order, this_angle));  
      eval(sprintf('neg%d = neg%d & low%d_%d;', ...
         this_angle, this_angle, this_order, this_angle));  
      
      
   end % angle
   
   % HIGH_ORDER AND LOW_ORDER are whatever we're printing
   %         (assuming we print bands)
   
   
   if (trackAngle >= 0)
      eval(sprintf('high%d = high%d_%d;', ...
         this_order , this_order, trackAngle));
      eval(sprintf('low%d = low%d_%d;', ...
         this_order , this_order, trackAngle));
   else 
      eval(sprintf('high%d = high; low%d = low;', ...
         this_order, this_order));
   end
   
end % order

 % FOUND EDGES
   
   orig1 = ones(R,C) *128;
   high=ones(R,C); low=ones(R,C);
   
   for this_order = Lowest:Highest
      eval(sprintf('high = high & high%d;', this_order));
      eval(sprintf('low = low & low%d;', this_order));
   end
   
   ind4 = find(high);
   ind6 = find(low);
   
   % high -> white    low->black
   orig1(ind4)=256*ones(size(ind4));
   orig1(ind6)=1*ones(size(ind6));
   
   %total_pix
   %total_int
   
   return;

