
function [SSAVD1] = reg_ecc(title_, orig, shftorig)

T = 100;                               % Template size 100
% search = 40;                      %Size of the search area
T2 = T/2;
[R, C] = size(orig);

imedges = 3;	                    %Edges of the image (excluded from search)

imcut1 = orig(imedges : R-imedges, imedges : C-imedges);	% Cut the edges
imcut2 = shftorig(imedges : R-imedges, imedges : C-imedges);
% i = 0;
% SSAVD1 = zeros( 2*T2 );
% SMSE = zeros( 2*T2 );
% for x = 110:40:160
%   for y = 110:40:160
%      tem = imcut1( x-T2 : x+T2, y-T2 : y+T2 );
%      f1 = tem - mean(mean( tem ));
%      % Create the Sum Absolute Values of the Differences (SAVD)
%      for m = x+1-T2:1:x+T2;                           %m - the center point of the search
%         for n = y+1-T2:1:y+T2;                        %max is N-T2
%            f2 = imcut2( m-T2 : m+T2, n-T2 : n+T2 );
%            f2 = f2 - mean(mean( f2 ));
%            SAVD(m-x+T2, n-y+T2)=sum(sum(abs( f1-f2 )));
%            MSE(m-x+T2, n-y+T2)=sum(sum(( f1-f2 ).^2));
%        end
%      end
% %    i=i + 1;                               %Find with vertical scanning
%    SSAVD1 = SSAVD1 + SAVD;
%    SMSE = SMSE + MSE;
%   end
% end

% figure;
% XX=[ -T2:1:T2 ];
% YY=[ -T2:1:T2 ];
% imagesc(XX, YY, SSAVD1);
% 
% title(title_);
% xlabel('Horizontal direction [pixels]');ylabel('Vertical direction [pixels]');

%%%%%%%% Get location %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% lex_loc = find(SSAVD1 == min(min( SSAVD1 )));                  %Lexicographic location of the shift
% div =lex_loc / T;                                                               %counts from up to down, right to left
% identified_locx = floor(div) + 1 - T2
% identified_locy = lex_loc - floor(div)*2*T2 - T2
% 
% lex_loc = find(SMSE == min(min( SMSE )));                  %Lexicographic location of the shift
% div =lex_loc / T;                                                               %counts from up to down, right to left
% identified_locx_MSE = floor(div) + 1 - T2
% identified_locy_MSE = lex_loc - floor(div)*2*T2 - T2
% 
% SSAVD1 = SMSE;
%%%%%%%%%%% PHASE-CORR %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
f1=fft2(imcut1);
f2=fft2(imcut2);

numerator=f2.*conj(f1);% abs(f2)*exp(jP2)*abs(f1)*exp(-jP1)=...*exp(p2-p1)
%denominator=abs(f2.*conj(f1));
denominator=abs(f2).*abs(f1);
fprintf(1,'\nBack transforming...');
phase=ifft2(numerator./denominator);
%phase=ifft2(numerator);

%imagesc(real(phase));
%colormap(gray);
XX_phase=-125:1:125;YY_phase=-125:1:125;
T=250;T2=T/2;

SSAVD1=abs(phase);

lex_loc = find(SSAVD1 == max(max( SSAVD1 ))); %Lexicographic location of the shift
div =lex_loc / T;                             %counts from up to down, right to left
identified_locx = floor(div) + 1 - T2
identified_locy = lex_loc - floor(div)*2*T2 - T2


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% figure;
% colormap(gray);
% imagesc(XX, YY, SSAVD1);
% title('Registration map (normalized SSAVD)');
% xlabel('Horizontal direction [pixels]');ylabel('Vertical direction [pixels]');

